#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "boomix"
#define PLUGIN_VERSION "1.00"

#include <sourcemod>
#include <sdktools>
#include <smlib>
#include <cstrike>
//#include <sdkhooks>

EngineVersion g_Game;
char g_sEggConfig[PLATFORM_MAX_PATH];
int g_iPlayerPrevButtons[MAXPLAYERS + 1];

public Plugin myinfo = 
{
	name = "Easter egg",
	author = PLUGIN_AUTHOR,
	description = "Easter egg",
	version = PLUGIN_VERSION,
	url = "http://happyeaster.com"
};

public void OnPluginStart()
{
	g_Game = GetEngineVersion();
	if(g_Game != Engine_CSGO)
	{
		SetFailState("This plugin is for CSGO/CSS only.");	
	}
	
	BuildPath(Path_SM, g_sEggConfig, sizeof(g_sEggConfig), "configs/eggs/eggs.cfg");
	HookEvent("round_start", Event_RoundStart);
	
}

public void OnMapStart()
{

	AddFileToDownloadsTable("materials/MOBENIC/v2/egg.vmt");
	AddFileToDownloadsTable("materials/MOBENIC/v2/egg.vtf");
	
	AddFileToDownloadsTable("models/spk_easteregg.dx80.vtx"); 
	AddFileToDownloadsTable("models/spk_easteregg.dx90.vtx"); 
	AddFileToDownloadsTable("models/spk_easteregg.mdl"); 
	AddFileToDownloadsTable("models/spk_easteregg.phy"); 
	AddFileToDownloadsTable("models/spk_easteregg.sw.vtx"); 
	AddFileToDownloadsTable("models/spk_easteregg.vvd"); 

}

public Action Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	CreateTimer(0.3, Remove_TakenEggs);
}

public Action Remove_TakenEggs(Handle tmr, any client)
{
	
	KeyValues kv = CreateKeyValues("Eggs");
	kv.ImportFromFile(g_sEggConfig);
 
	if (kv.GotoFirstSubKey())
	{
		do
		{
			char found[10];
			kv.GetString("found", found, sizeof(found));
			int ifound = StringToInt(found);
			
			if(ifound == 1)
			{
				char nameinconfig[120];
				kv.GetSectionName(nameinconfig, sizeof(nameinconfig));
					
				int ent = 0;
				while ((ent = FindEntityByClassname(ent, "prop_dynamic")) != INVALID_ENT_REFERENCE) {
					if(IsValidEntity(ent) && IsValidEdict(ent)) {
						char entglobaname[50];
						Entity_GetGlobalName(ent, entglobaname, sizeof(entglobaname));
						
						if (StrEqual(entglobaname, nameinconfig)) {
							if(IsValidEntity(ent)) {
								Entity_Kill(ent);
							}
						}
						
					}
				}
					
			}
			
		} while (kv.GotoNextKey());
		
		delete kv;
	}

}

public Action OnPlayerRunCmd(int client, int &iButtons, int &iImpulse, float fVelocity[3], float fAngles[3], int &iWeapon) 
{

	if(IsClientInGame(client) && IsPlayerAlive(client) && !IsAdmin(client))
	{
		if(!(g_iPlayerPrevButtons[client] & IN_USE) && iButtons & IN_USE)
		{
			int egg = GetTargetBlock(client);
			
			if(IsValidEntity(egg))
			{
				float EggOrg[3];
				float PlayerOrg[3];
				
				GetEntPropVector(egg, Prop_Send, "m_vecOrigin", EggOrg);
				GetClientAbsOrigin(client, PlayerOrg);
				
				float distance = GetVectorDistance(EggOrg, PlayerOrg);
				
				if(distance < 80.0)
				{
					char eggname[120];
					Entity_GetGlobalName(egg, eggname, sizeof(eggname));
					
					char username[128];
					char steamid64[40];
					char founder[168];
					GetClientName(client, username, sizeof(username));
					GetClientAuthId(client, AuthId_SteamID64, steamid64, sizeof(steamid64));
					
					Format(founder, sizeof(founder), "Username: %s | SteamID64: %s", username, steamid64);
					EggIsFound(eggname, founder);
					RemoveEggFromMap(egg);
					PrintToChatAll("\x3 \x4 [EasterEgg] \x1--------------------------------------");
					PrintToChatAll("\x3 \x4 [EasterEgg] \x2%s \x1just found egg in map! ", username);
					PrintToChatAll("\x3 \x4 [EasterEgg] \x1--------------------------------------");
					
				}
					
			}
		}
		g_iPlayerPrevButtons[client] = iButtons;
	}
	
	

}

public void EggIsFound(char eggname[120], char founder[168])
{
	
	KeyValues kv = CreateKeyValues("Eggs");
	kv.ImportFromFile(g_sEggConfig);
 
	if (kv.GotoFirstSubKey())
	{
		char nameinconfig[120];
		do
		{
			kv.GetSectionName(nameinconfig, sizeof(nameinconfig));
			
			if(StrEqual(nameinconfig, eggname))
			{
				kv.SetString("found", "1");
				kv.SetString("founder", founder);
				kv.Rewind();
				kv.ExportToFile(g_sEggConfig);
			}
			
		} while (kv.GotoNextKey());
		
		delete kv;
		
	}

}

public void RemoveEggFromMap(int entity)
{

	if(IsValidEntity(entity))
		AcceptEntityInput(entity, "Kill");

}


public bool IsAdmin(int client)
{
	if(Client_HasAdminFlags(client, ADMFLAG_GENERIC) || Client_HasAdminFlags(client, ADMFLAG_ROOT) || Client_HasAdminFlags(client, ADMFLAG_BAN))
		return true;
	else return false;
}


int GetTargetBlock(int client)
{
	int entity = GetClientAimTarget(client, false);
	if (IsValidEntity(entity))
	{
		char classname[32];
		GetEdictClassname(entity, classname, 32);
		
		if (StrContains(classname, "prop_dynamic") != -1)
			return entity;
	}
	return -1;
}